#pragma once
//======================================================================
//	fips-197	AES		Encoder / Decorder
//======================================================================
//
//	{vÓA`drÍSIMD߁iSSE2jŏ鎖
//	ׂ݂ɊJ܂B̒mIɂYłB
//
//	botA`drÍׂSIMDiAVXj
//	ǉ邻łAȑObotڂĂob
//	SIMD߂ɂÍE݂镨łB
//	"SSE2"ɑΉĂCPUł΁A삷͂łB
//
//	A{NXA\[XR[h̗pۂ́A񂭂B
//	A{NXA\[XR[h̗pɂ蔭Ȃ
//	Qɂ܂Ă͖@eőɂĐӔC𕉂܂̂ŁA
//	gp҂̐ӔČAp΍KłB
//
//	ǵAb++̃\[XǂłB
//	"main.c"́A{NX"AES"̎gp@̃TvxɂlB
//
//						Copyright (c) A.Watanabe (2010)
//
//----------------------------------------------------------------------
//	Revision
//		2010.12.27	
//		2010.12.28	啔AZuiMASMĵA
//					b++ŏB
//======================================================================

/****************************************************************/
/*			萔`											*/
/****************************************************************/
#define		Nb		4			//Number of columns (32-bit words) comprising the State.
								//For this standard, Nb = 4. (Also see Sec. 6.3.)
#define		Nbb		Nb*4		//[Byte]

/****************************************************************/
/*			vg^Cv錾									*/
/****************************************************************/
//NXɂ͂ȂBAZuꂩĂԁB
//extern "C"{
//	unsigned	int		__stdcall	RotWord(unsigned int data);		//
//	unsigned	int		__stdcall	SubWord(unsigned int data);		//
//	unsigned	int		__stdcall	InvSubWord(unsigned int data);	//
//}
//
//AZuŏꂽ֐	"AES_sse.asm"
//extern "C"{
//				__m128i	__fastcall	AES_SSE_Cipher(unsigned char cNr,unsigned int *ptrKs);
//				__m128i	__fastcall	AES_SSE_InvCipher(unsigned char cNr,unsigned int *ptrKs);
//}

/****************************************************************/
/*			NX`											*/
/****************************************************************/
class __declspec(align(16)) AES
{
public:
	//Variable
__declspec(align(16)) unsigned	int	w[60];	//Key Schedule	(16byte align)
	unsigned	char	Nk;					//Number of 32-bit words comprising the Cipher Key.
											//For this standard, Nk = 4, 6, or 8. (Also see Sec. 6.3.)
	unsigned	char	Nr;					//Number of rounds, which is a function of Nk and Nb (which is fixed).
											//For this standard, Nr = 10, 12, or 14. (Also see Sec. 6.3.)

public:
	//Function
	AES();											//
	AES(char cNk,const unsigned char Key[]);		//XPW[tŃNX쐬
	~AES(void);										//

	__m128i	mul(__m128i data, unsigned char n);					//4,2	Multiplication

	void	KeyExpansion(char cNK, const unsigned char *key);	//5.2	Key Expansion
	unsigned	int		RotWord(unsigned int data);				//
	unsigned	int		SubWord(unsigned int data);				//
	unsigned	int		InvSubWord(unsigned int data);			//

	void	Cipher_One(void *ind, void *outd);					//
	__m128i	Cipher(__m128i data);								//5.1	Cipher
	__m128i	SubBytes(__m128i data);								//5.1.1	SubBytes
	__m128i	ShiftRows(__m128i data);							//5.1.2	ShiftRows
	__m128i	MixColumns(__m128i data);							//5.1.3	MixColumns
	__m128i	AddRoundKey(__m128i data, int i);					//5.1.4	AddRoundKey

	void	InvCipher_One(void *ind, void *outd);				//
	__m128i	InvCipher(__m128i data);							//5.3	InvCipher
	__m128i	InvShiftRows(__m128i data);							//5.3.1	InvShiftRows
	__m128i	InvSubBytes(__m128i data);							//5.3.2	InvSubBytes
	__m128i	InvMixColumns(__m128i data);						//5.3.3	InvMixColumns
	__m128i	InvAddRoundKey(__m128i data, int i);				//5.3.4	InvAddRoundKey
};
